import { deepExtend, setRangeValue } from "tsparticles-engine";
const fixOptions = (options) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    if (options.retina_detect !== undefined) {
        options.detectRetina = options.retina_detect;
    }
    const particlesOptions = options.particles;
    if (particlesOptions) {
        particlesOptions.links = deepExtend(particlesOptions.links, particlesOptions.line_linked);
        const moveOptions = particlesOptions.move;
        if (moveOptions) {
            if (moveOptions.attract) {
                if (!moveOptions.attract.rotate) {
                    moveOptions.attract.rotate = {};
                }
                if (moveOptions.attract.rotateX !== undefined) {
                    moveOptions.attract.rotate.x = moveOptions.attract.rotateX;
                }
                if (moveOptions.attract.rotateY !== undefined) {
                    moveOptions.attract.rotate.y = moveOptions.attract.rotateY;
                }
            }
            if (moveOptions.out_mode !== undefined) {
                if (!moveOptions.outModes) {
                    moveOptions.outModes = { default: moveOptions.out_mode };
                }
                else {
                    if (typeof moveOptions.outModes === "object") {
                        moveOptions.outModes.default = moveOptions.out_mode;
                    }
                    else {
                        moveOptions.outModes = moveOptions.out_mode;
                    }
                }
            }
        }
        if (((_b = (_a = particlesOptions.number) === null || _a === void 0 ? void 0 : _a.density) === null || _b === void 0 ? void 0 : _b.value_area) !== undefined) {
            particlesOptions.number.density.area = particlesOptions.number.density.value_area;
        }
        const opacityOptions = particlesOptions.opacity;
        if (opacityOptions) {
            if (opacityOptions.random) {
                opacityOptions.value = setRangeValue((_c = opacityOptions.value) !== null && _c !== void 0 ? _c : 1, 0);
            }
            if (opacityOptions.anim) {
                opacityOptions.animation = deepExtend(opacityOptions.animation, opacityOptions.anim);
                if (opacityOptions.anim.enable && opacityOptions.anim.opacity_min !== undefined) {
                    opacityOptions.value = setRangeValue((_d = opacityOptions.value) !== null && _d !== void 0 ? _d : opacityOptions.anim.opacity_min, opacityOptions.anim.opacity_min);
                }
            }
        }
        if ((_e = particlesOptions.shape) === null || _e === void 0 ? void 0 : _e.stroke) {
            particlesOptions.stroke = deepExtend(particlesOptions.stroke, particlesOptions.shape.stroke);
        }
        if ((_f = particlesOptions.shape) === null || _f === void 0 ? void 0 : _f.polygon) {
            if (!particlesOptions.shape.options) {
                particlesOptions.shape.options = {};
            }
            particlesOptions.shape.options.polygon = deepExtend(particlesOptions.shape.options.polygon, particlesOptions.shape.polygon);
        }
        if ((_g = particlesOptions.shape) === null || _g === void 0 ? void 0 : _g.image) {
            if (!particlesOptions.shape.options) {
                particlesOptions.shape.options = {};
            }
            particlesOptions.shape.options.image = deepExtend(particlesOptions.shape.options.image, particlesOptions.shape.image);
        }
        const sizeOptions = particlesOptions.size;
        if (sizeOptions) {
            if (sizeOptions.random) {
                sizeOptions.value = setRangeValue((_h = sizeOptions.value) !== null && _h !== void 0 ? _h : 1, 0);
            }
            if (sizeOptions.anim) {
                sizeOptions.animation = deepExtend(sizeOptions.animation, sizeOptions.anim);
                if (sizeOptions.anim.enable && sizeOptions.anim.size_min !== undefined) {
                    sizeOptions.value = setRangeValue((_j = sizeOptions.value) !== null && _j !== void 0 ? _j : sizeOptions.anim.size_min, sizeOptions.anim.size_min);
                }
            }
        }
    }
    const interactivityOptions = options.interactivity;
    if (interactivityOptions) {
        if (interactivityOptions.detect_on !== undefined) {
            interactivityOptions.detectsOn = interactivityOptions.detect_on;
        }
        const eventsOptions = interactivityOptions.events;
        if (eventsOptions) {
            if (eventsOptions.onclick) {
                eventsOptions.onClick = deepExtend(eventsOptions.onClick, eventsOptions.onclick);
            }
            if (eventsOptions.onhover) {
                eventsOptions.onHover = deepExtend(eventsOptions.onHover, eventsOptions.onhover);
            }
        }
        const modesOptions = interactivityOptions.modes;
        if (modesOptions) {
            if ((_k = modesOptions.grab) === null || _k === void 0 ? void 0 : _k.line_linked) {
                modesOptions.grab.links = deepExtend(modesOptions.grab.links, modesOptions.grab.line_linked);
            }
            if (((_l = modesOptions.push) === null || _l === void 0 ? void 0 : _l.particles_nb) !== undefined) {
                modesOptions.push.quantity = modesOptions.push.particles_nb;
            }
            if (((_m = modesOptions.remove) === null || _m === void 0 ? void 0 : _m.particles_nb) !== undefined) {
                modesOptions.remove.quantity = modesOptions.remove.particles_nb;
            }
        }
    }
    return options;
};
export { fixOptions };
